import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class JDialitComms extends Thread
{
    public static final String COMMAND_DIAL="DIAL";
    public static final String COMMAND_LIST="LIST";
    public static final String COMMAND_STAT="STAT";
    public static final String COMMAND_STOP="STOP";


    private static final int srv_sock_number=666;

    private JDialitFrame frame;
    private boolean keeprunning=true;
    private String command;
    private String param;
    private Socket server_sock;
    private BufferedReader from_srv;
    private PrintWriter to_srv;

    public JDialitComms(JDialitFrame frame)
	{
	    this.frame = frame;
	}

    public void requeststop()
	{
	    keeprunning=false;
	}

    public synchronized int schedule_command(String command,String param)
	{
	    this.command=command;
	    this.param=param;
	    this.notify();
	    return 0;

	}

    public synchronized void run()
	{

	    String server = JOptionPane.showInputDialog(frame,"Dialitd Server");
	    List cmd_reply;

	    start_connection(server);

	    // get list
	    frame.set_list_entries(execute_command(COMMAND_LIST,null));

	    while(keeprunning)
	    {
		try {this.wait(); }/* wait for command to be issued */
		catch (InterruptedException e) { /* ignore */ }
		if (keeprunning!=true)
		    return;

		cmd_reply=execute_command(command,param);//do scheduled command

		check_cmd_reply(command,cmd_reply);//action reply status

	    }

	    try{ server_sock.close(); }
	    catch (IOException e) { }

	}


    private synchronized List execute_command(String command,String param)
	{
	    String line;
	    List res_list = new LinkedList();
	    boolean another_line=false;

	    if (command!=null)
	    {
		if (to_srv==null)
		    return res_list;

		//send command
		if (param==null)
		    to_srv.println(command);
		else
		    to_srv.println(command + " " + param);

		to_srv.flush();
	    }

	    do
	    {
		try {

		    line=from_srv.readLine();

		    //System.out.println(line);

		    if (line.charAt(3) != ' ')
			another_line=true;
		    else
			another_line=false;

		    switch(line.charAt(0))
		    {
		    case '1':
			//human comment - ignore
			break;

		    case '2':
			res_list.add(line.substring(4));
			break;

		    default:
			System.out.println("Unknown reply line :"+line);

		    }
		} catch (java.io.IOException ioe) {
		    System.out.println("error reading response: "+ioe);
		}
	    }while(another_line);


	    //listen for reply
	    // numeric without text is end of reply
	    // 1xx is ok
	    // 2xxamt_read=from_srv.read(buffer)) >0)
	    // return list of strings for each line

	    return res_list;
	}

    private boolean start_connection(String server)
	{
	    frame.setTitle("Connecting To Dialitd Server " + server);

	    // open socket
	    try { server_sock = new Socket(server,srv_sock_number); }
	    catch (UnknownHostException e) {return false; }
	    catch (IOException e) {return false; }

	    // setup streams
	    try{
		from_srv = new BufferedReader(new InputStreamReader(server_sock.getInputStream()));

		to_srv = new PrintWriter(new OutputStreamWriter(server_sock.getOutputStream()));

	    }
	    catch (IOException e) {return false; }
	    execute_command(null,null);//collect welcome line

	    frame.setTitle("Connected to " + server);

	    return true;

	}

    private void check_cmd_reply(String command,List cmd_reply)
	{
	    if(command==COMMAND_STAT)
	    {
		if (cmd_reply.get(0).toString().endsWith("DOWN"))
		    frame.set_state(0);
		else if (cmd_reply.get(0).toString().endsWith("CONNECTING"))
		    frame.set_state(1);
		else
		    frame.set_state(2);

	    }
	    if(command==COMMAND_DIAL)
	    {
		frame.set_state(1);
	    }

	}
}
