import javax.swing.*;          //This is the final package name.
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;

public class JDialitFrame extends JFrame
{
    private static String labelPrefix = "Connection is ";
    private JButton dial_button;
    private JButton stop_button;
    private JLabel label;
    private JPanel pane;
    private DefaultListModel list_entries;
    private JList list;
    private JDialitComms comms;
    private int state=-1;

    JDialitFrame(String title)
	{
	    super(title);

	    Component contents = createComponents();

	    getContentPane().add(contents, BorderLayout.CENTER);
	}

    public void set_list_entries(java.util.List new_list)
	{
	    list_entries.removeAllElements();
	    for(Iterator i = new_list.iterator();i.hasNext();)
		list_entries.addElement(i.next());

	}


    public void setComms(JDialitComms comms)
	{
	    this.comms = comms;
	}

    public Component createComponents() {
	label = new JLabel("Connection is");

        dial_button = new JButton("Dial");
	dial_button.setEnabled(false);
        dial_button.addActionListener(new ActionListener()
	    {
		public void actionPerformed(ActionEvent e)
		    {
		    comms.schedule_command(comms.COMMAND_DIAL,
					   list.getSelectedValue().toString());
		    }
	    });

        stop_button = new JButton("Stop");
        stop_button.addActionListener(new ActionListener()
	    {
		public void actionPerformed(ActionEvent e)
		    { comms.schedule_command(comms.COMMAND_STOP,null); }
	    });


	list_entries=new DefaultListModel();

	list=new JList(list_entries);
	list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list.addListSelectionListener(new ListSelectionListener()
	    {
		public void valueChanged(ListSelectionEvent e)
		    {
			dial_button.setEnabled(true);
		    }
	    });

        /*
         * An easy way to put space between a top-level container
         * and its contents is to put the contents in a JPanel
         * that has an "empty" border.
         */
        pane = new JPanel();
        pane.setBorder(BorderFactory.createEmptyBorder(
	    10, //top
	    30, //left
	    10, //bottom
	    30) //right
	    );
        pane.setLayout(new BorderLayout(0, 1));
        pane.add(label,"North");
	pack();
        return pane;
    }

    public void set_state(int state)
	{
	    if(this.state!=state)
	    {
		this.state=state;
		if(state==2)
		{
		    label.setText(labelPrefix + "UP");
		    pane.remove(dial_button);
		    pane.remove(list);
		    pane.add(stop_button,"South");
		    pack();
		}
		else if(state== 1)
		{
		    label.setText(labelPrefix + "CONNECTING");
		    pane.remove(stop_button);
		    pane.remove(dial_button);
		    pane.remove(list);
		    pack();

		}
		else
		{
		    label.setText(labelPrefix + "DOWN");
		    pane.remove(stop_button);
		    pane.add(list,"Center");
		    pane.add(dial_button,"South");
		    pack();
		}
	    }
	    //System.out.println("set state :"+stat);
	}

}
